#include <stdio.h>
#include <stdlib.h>

#include <omp.h>

#define LOOP_SIZE 64

#define THREAD_COUNTS	64


static int thread_count[THREAD_COUNTS];

int main (int argc, char **argv) {

	int num_threads=1;
	int x,y,c,i,tid,nthreads;

	/* Set number of threads from the command line */
	if (argc>1) {
		num_threads=atoi(argv[1]);
	}


#pragma omp parallel shared(thread_count) private(x,y,c,i,tid) num_threads(num_threads)
{

	tid=omp_get_thread_num();
	if (tid==0) {
		nthreads=omp_get_num_threads();
		printf("Using %d threads\n",nthreads);
		fflush(stdout);
	}


#if 0
	#pragma omp for
	for (i=0; i < LOOP_SIZE; i++) {
		printf("%*d\n",tid,i);

	}
#endif


#pragma omp barrier

	if (tid==0) {
		printf("Test 1\n");
		fflush(stdout);
	}
#pragma omp barrier

	#pragma omp for
	for(x=0;x<3;x++) {
		for(y=0;y<3;y++) {
			for (c=0;c<3;c++) {
				if (tid<THREAD_COUNTS) thread_count[tid]++;
			}
		}

	}



#pragma omp barrier

	if (tid==0) {
		for(i=0;i<THREAD_COUNTS;i++) {
			if (thread_count[i]) printf("%d: %d\n",i,thread_count[i]);
		}
		fflush(stdout);
	}

	/* test 3 */

#pragma omp barrier

	if (tid==0) {
		printf("Test 2\n");
		fflush(stdout);
	}
	thread_count[tid]=0;

#pragma omp barrier

	#pragma omp for collapse(2)
	for(x=0;x<3;x++) {
		for(y=0;y<3;y++) {
			for (c=0;c<3;c++) {
				if (tid<THREAD_COUNTS) thread_count[tid]++;
			}
		}

	}


#pragma omp barrier

	if (tid==0) {
		for(i=0;i<THREAD_COUNTS;i++) {
			if (thread_count[i]) printf("%d: %d\n",i,thread_count[i]);
		}
		fflush(stdout);
	}

#pragma omp barrier




}

	printf("Main thread exiting\n");

}
